/*
 * Internal Utility API
 * This API allows you to access internal data.
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package org.wso2.am.integration.clients.internal.api;

import org.wso2.am.integration.clients.internal.ApiCallback;
import org.wso2.am.integration.clients.internal.ApiClient;
import org.wso2.am.integration.clients.internal.ApiException;
import org.wso2.am.integration.clients.internal.ApiResponse;
import org.wso2.am.integration.clients.internal.Configuration;
import org.wso2.am.integration.clients.internal.Pair;
import org.wso2.am.integration.clients.internal.ProgressRequestBody;
import org.wso2.am.integration.clients.internal.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.wso2.am.integration.clients.internal.api.dto.ErrorDTO;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class RetrievingRuntimeArtifactsApi {
    private ApiClient apiClient;

    public RetrievingRuntimeArtifactsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public RetrievingRuntimeArtifactsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for endpointCertificatesGet
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param alias **Search condition**.   Alias  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call endpointCertificatesGetCall(String xWSO2Tenant, String alias, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/endpoint-certificates";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (alias != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("alias", alias));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xWSO2Tenant != null)
        localVarHeaderParams.put("xWSO2Tenant", apiClient.parameterToString(xWSO2Tenant));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call endpointCertificatesGetValidateBeforeCall(String xWSO2Tenant, String alias, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'xWSO2Tenant' is set
        if (xWSO2Tenant == null) {
            throw new ApiException("Missing the required parameter 'xWSO2Tenant' when calling endpointCertificatesGet(Async)");
        }
        

        com.squareup.okhttp.Call call = endpointCertificatesGetCall(xWSO2Tenant, alias, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get all the endpoint certificates for given alias.
     * This will provide access to 
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param alias **Search condition**.   Alias  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void endpointCertificatesGet(String xWSO2Tenant, String alias) throws ApiException {
        endpointCertificatesGetWithHttpInfo(xWSO2Tenant, alias);
    }

    /**
     * Get all the endpoint certificates for given alias.
     * This will provide access to 
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param alias **Search condition**.   Alias  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> endpointCertificatesGetWithHttpInfo(String xWSO2Tenant, String alias) throws ApiException {
        com.squareup.okhttp.Call call = endpointCertificatesGetValidateBeforeCall(xWSO2Tenant, alias, null, null);
        return apiClient.execute(call);
    }

    /**
     * Get all the endpoint certificates for given alias. (asynchronously)
     * This will provide access to 
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param alias **Search condition**.   Alias  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call endpointCertificatesGetAsync(String xWSO2Tenant, String alias, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = endpointCertificatesGetValidateBeforeCall(xWSO2Tenant, alias, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for gaConfigGet
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param apiId **Search condition**.   Api ID  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call gaConfigGetCall(String xWSO2Tenant, String apiId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/ga-config";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (apiId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("apiId", apiId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xWSO2Tenant != null)
        localVarHeaderParams.put("xWSO2Tenant", apiClient.parameterToString(xWSO2Tenant));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call gaConfigGetValidateBeforeCall(String xWSO2Tenant, String apiId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'xWSO2Tenant' is set
        if (xWSO2Tenant == null) {
            throw new ApiException("Missing the required parameter 'xWSO2Tenant' when calling gaConfigGet(Async)");
        }
        

        com.squareup.okhttp.Call call = gaConfigGetCall(xWSO2Tenant, apiId, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get Google analytics config related to tenant.
     * This will provide access to runtime artifacts in database. 
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param apiId **Search condition**.   Api ID  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void gaConfigGet(String xWSO2Tenant, String apiId) throws ApiException {
        gaConfigGetWithHttpInfo(xWSO2Tenant, apiId);
    }

    /**
     * Get Google analytics config related to tenant.
     * This will provide access to runtime artifacts in database. 
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param apiId **Search condition**.   Api ID  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> gaConfigGetWithHttpInfo(String xWSO2Tenant, String apiId) throws ApiException {
        com.squareup.okhttp.Call call = gaConfigGetValidateBeforeCall(xWSO2Tenant, apiId, null, null);
        return apiClient.execute(call);
    }

    /**
     * Get Google analytics config related to tenant. (asynchronously)
     * This will provide access to runtime artifacts in database. 
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param apiId **Search condition**.   Api ID  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call gaConfigGetAsync(String xWSO2Tenant, String apiId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = gaConfigGetValidateBeforeCall(xWSO2Tenant, apiId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for runtimeArtifactsGet
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param apiId **Search condition**.   Api ID  (optional)
     * @param gatewayLabel **Search condition**.  label associated with the APIs  (optional)
     * @param type **Search condition**.  type of gateway  (optional)
     * @param name **Search condition**.  name of API  (optional)
     * @param version **Search condition**.  version of API  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call runtimeArtifactsGetCall(String xWSO2Tenant, String apiId, String gatewayLabel, String type, String name, String version, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/runtime-artifacts";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (apiId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("apiId", apiId));
        if (gatewayLabel != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("gatewayLabel", gatewayLabel));
        if (type != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type", type));
        if (name != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("name", name));
        if (version != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("version", version));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xWSO2Tenant != null)
        localVarHeaderParams.put("xWSO2Tenant", apiClient.parameterToString(xWSO2Tenant));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call runtimeArtifactsGetValidateBeforeCall(String xWSO2Tenant, String apiId, String gatewayLabel, String type, String name, String version, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'xWSO2Tenant' is set
        if (xWSO2Tenant == null) {
            throw new ApiException("Missing the required parameter 'xWSO2Tenant' when calling runtimeArtifactsGet(Async)");
        }
        

        com.squareup.okhttp.Call call = runtimeArtifactsGetCall(xWSO2Tenant, apiId, gatewayLabel, type, name, version, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get all the runtime artifacts for a given API UUID and gateway label
     * This will provide access to runtime artifacts in database. 
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param apiId **Search condition**.   Api ID  (optional)
     * @param gatewayLabel **Search condition**.  label associated with the APIs  (optional)
     * @param type **Search condition**.  type of gateway  (optional)
     * @param name **Search condition**.  name of API  (optional)
     * @param version **Search condition**.  version of API  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void runtimeArtifactsGet(String xWSO2Tenant, String apiId, String gatewayLabel, String type, String name, String version) throws ApiException {
        runtimeArtifactsGetWithHttpInfo(xWSO2Tenant, apiId, gatewayLabel, type, name, version);
    }

    /**
     * Get all the runtime artifacts for a given API UUID and gateway label
     * This will provide access to runtime artifacts in database. 
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param apiId **Search condition**.   Api ID  (optional)
     * @param gatewayLabel **Search condition**.  label associated with the APIs  (optional)
     * @param type **Search condition**.  type of gateway  (optional)
     * @param name **Search condition**.  name of API  (optional)
     * @param version **Search condition**.  version of API  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> runtimeArtifactsGetWithHttpInfo(String xWSO2Tenant, String apiId, String gatewayLabel, String type, String name, String version) throws ApiException {
        com.squareup.okhttp.Call call = runtimeArtifactsGetValidateBeforeCall(xWSO2Tenant, apiId, gatewayLabel, type, name, version, null, null);
        return apiClient.execute(call);
    }

    /**
     * Get all the runtime artifacts for a given API UUID and gateway label (asynchronously)
     * This will provide access to runtime artifacts in database. 
     * @param xWSO2Tenant This is used to specify the tenant domain, where the resource need to be   retrieved from.  (required)
     * @param apiId **Search condition**.   Api ID  (optional)
     * @param gatewayLabel **Search condition**.  label associated with the APIs  (optional)
     * @param type **Search condition**.  type of gateway  (optional)
     * @param name **Search condition**.  name of API  (optional)
     * @param version **Search condition**.  version of API  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call runtimeArtifactsGetAsync(String xWSO2Tenant, String apiId, String gatewayLabel, String type, String name, String version, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = runtimeArtifactsGetValidateBeforeCall(xWSO2Tenant, apiId, gatewayLabel, type, name, version, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
