/*
 * Internal Utility API
 * This API allows you to access internal data.
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package org.wso2.am.integration.clients.internal.api;

import org.wso2.am.integration.clients.internal.ApiCallback;
import org.wso2.am.integration.clients.internal.ApiClient;
import org.wso2.am.integration.clients.internal.ApiException;
import org.wso2.am.integration.clients.internal.ApiResponse;
import org.wso2.am.integration.clients.internal.Configuration;
import org.wso2.am.integration.clients.internal.Pair;
import org.wso2.am.integration.clients.internal.ProgressRequestBody;
import org.wso2.am.integration.clients.internal.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.wso2.am.integration.clients.internal.api.dto.ErrorDTO;
import org.wso2.am.integration.clients.internal.api.dto.SynapseAttributesDTO;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class RetrievingSynapseArtifactsApi {
    private ApiClient apiClient;

    public RetrievingSynapseArtifactsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public RetrievingSynapseArtifactsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for synapseAttributesGet
     * @param apiName **Search condition**.   API Name  (optional)
     * @param tenantDomain **Search condition**.  tenantDomain associated with the API  (optional)
     * @param version **Search condition**. version of the API  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call synapseAttributesGetCall(String apiName, String tenantDomain, String version, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/synapse-attributes";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (apiName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("apiName", apiName));
        if (tenantDomain != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("tenantDomain", tenantDomain));
        if (version != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("version", version));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call synapseAttributesGetValidateBeforeCall(String apiName, String tenantDomain, String version, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = synapseAttributesGetCall(apiName, tenantDomain, version, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get API UUID and label associated with it
     * This will provide access to synapse artifacts in database. 
     * @param apiName **Search condition**.   API Name  (optional)
     * @param tenantDomain **Search condition**.  tenantDomain associated with the API  (optional)
     * @param version **Search condition**. version of the API  (optional)
     * @return SynapseAttributesDTO
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public SynapseAttributesDTO synapseAttributesGet(String apiName, String tenantDomain, String version) throws ApiException {
        ApiResponse<SynapseAttributesDTO> resp = synapseAttributesGetWithHttpInfo(apiName, tenantDomain, version);
        return resp.getData();
    }

    /**
     * Get API UUID and label associated with it
     * This will provide access to synapse artifacts in database. 
     * @param apiName **Search condition**.   API Name  (optional)
     * @param tenantDomain **Search condition**.  tenantDomain associated with the API  (optional)
     * @param version **Search condition**. version of the API  (optional)
     * @return ApiResponse&lt;SynapseAttributesDTO&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<SynapseAttributesDTO> synapseAttributesGetWithHttpInfo(String apiName, String tenantDomain, String version) throws ApiException {
        com.squareup.okhttp.Call call = synapseAttributesGetValidateBeforeCall(apiName, tenantDomain, version, null, null);
        Type localVarReturnType = new TypeToken<SynapseAttributesDTO>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get API UUID and label associated with it (asynchronously)
     * This will provide access to synapse artifacts in database. 
     * @param apiName **Search condition**.   API Name  (optional)
     * @param tenantDomain **Search condition**.  tenantDomain associated with the API  (optional)
     * @param version **Search condition**. version of the API  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call synapseAttributesGetAsync(String apiName, String tenantDomain, String version, final ApiCallback<SynapseAttributesDTO> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = synapseAttributesGetValidateBeforeCall(apiName, tenantDomain, version, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<SynapseAttributesDTO>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
